DECLARE SUB rotateXY (angle!) 'en degr
DECLARE SUB rotateXZ (angle!) 'en degr
DECLARE SUB rotateYZ (angle!) 'en degr
DECLARE SUB projection ()
DECLARE SUB drawfigure (couleur!)
DECLARE FUNCTION y3d! (ycoor!, zcoor!, xH!)
DECLARE FUNCTION x3d! (xcoor!, zcoor!, yH!)

DIM SHARED xpos, ypos, zpos
DIM SHARED nbpoint, nblink, nbcercle

DIM SHARED pi
pi = 3.141592653589793#
comd$ = COMMAND$
GOSUB loadobject

SCREEN 9, 0, 1, 0

WHILE k$ <> CHR$(27)
k$ = INKEY$

IF k$ = "l" THEN GOSUB loadobject
k = INP(96)
IF k = 75 THEN drawfigure 0: xpos = xpos - 5
IF k = 77 THEN drawfigure 0: xpos = xpos + 5
IF k = 72 THEN drawfigure 0: ypos = ypos - 5
IF k = 80 THEN drawfigure 0: ypos = ypos + 5
IF k = 16 THEN drawfigure 0: zpos = zpos + 5
IF k = 30 THEN drawfigure 0: zpos = zpos - 5
IF k = 83 THEN drawfigure 0: rotateXY -5
IF k = 81 THEN drawfigure 0: rotateXY 5
IF k = 82 THEN drawfigure 0: rotateXZ -5
IF k = 73 THEN drawfigure 0: rotateXZ 5
IF k = 71 THEN drawfigure 0: rotateYZ -5
IF k = 79 THEN drawfigure 0: rotateYZ 5

projection
drawfigure 15

PCOPY 1, 0
WEND
END

loadobject:
CLS
SCREEN 9, 0, 0, 0

IF comd$ <> "" THEN nom$ = comd$
IF comd$ = "" THEN INPUT "Nom du fichier .3d"; nom$
nom$ = UCASE$(nom$)
IF RIGHT$(nom$, 3) <> ".3D" THEN nom$ = nom$ + ".3D"
OPEN "I", #1, nom$

INPUT #1, nbpoint
REDIM SHARED coor(nbpoint, 3), xecran(nbpoint), yecran(nbpoint)
FOR j = 1 TO 3
        FOR i = 1 TO nbpoint
                INPUT #1, coor(i, j)
        NEXT i
NEXT j

INPUT #1, nblink
REDIM SHARED link(nblink, 2)
FOR i = 1 TO nblink
        INPUT #1, link(i, 1), link(i, 2)
NEXT i

INPUT #1, coor(0, 1), coor(0, 2), coor(0, 3)

INPUT #1, nbcercle
REDIM SHARED cercle(nbcercle, 2)
FOR i = 1 TO nbcercle
        INPUT #1, cercle(i, 1), cercle(i, 2)
NEXT i

CLOSE
comd$ = ""

SCREEN 9, 0, 1, 0
RETURN

SUB drawfigure (couleur)
FOR i = 1 TO nblink
        LINE (xecran(link(i, 1)), yecran(link(i, 1)))-(xecran(link(i, 2)), yecran(link(i, 2))), couleur
NEXT i
FOR i = 1 TO nbcercle
        x = xecran(cercle(i, 1))
        y = yecran(cercle(i, 1))
        rayon = x3d(cercle(i, 2), coor(cercle(i, 1), 3) + zpos, 0)
        CIRCLE (x, y), rayon, couleur, , , 1
NEXT i
END SUB

SUB projection
FOR i = 1 TO nbpoint
xecran(i) = x3d(coor(i, 1) + xpos, coor(i, 3) + zpos, 320)
yecran(i) = y3d(coor(i, 2) + ypos, coor(i, 3) + zpos, 50)
NEXT i
END SUB

SUB rotateXY (angle)
angle = pi / (180 / angle)
FOR i = 1 TO nbpoint
XY = (coor(i, 1) - coor(0, 1)) * COS(angle) - (coor(i, 2) - coor(0, 2)) * SIN(angle)
YX = (coor(i, 2) - coor(0, 2)) * COS(angle) + (coor(i, 1) - coor(0, 1)) * SIN(angle)
coor(i, 1) = XY + coor(0, 1)
coor(i, 2) = YX + coor(0, 2)
NEXT i
END SUB

SUB rotateXZ (angle)
angle = pi / (180 / angle)
FOR i = 1 TO nbpoint
XZ = (coor(i, 1) - coor(0, 1)) * COS(angle) - (coor(i, 3) - coor(0, 3)) * SIN(angle)
ZX = (coor(i, 3) - coor(0, 3)) * COS(angle) + (coor(i, 1) - coor(0, 1)) * SIN(angle)
coor(i, 1) = XZ + coor(0, 1)
coor(i, 3) = ZX + coor(0, 3)
NEXT i
END SUB

SUB rotateYZ (angle)
angle = pi / (180 / angle)
FOR i = 1 TO nbpoint
YZ = (coor(i, 2) - coor(0, 2)) * COS(angle) - (coor(i, 3) - coor(0, 3)) * SIN(angle)
ZY = (coor(i, 3) - coor(0, 3)) * COS(angle) + (coor(i, 2) - coor(0, 2)) * SIN(angle)
coor(i, 2) = YZ + coor(0, 2)
coor(i, 3) = ZY + coor(0, 3)
NEXT i
END SUB

FUNCTION x3d (xcoor, zcoor, xH)
IF zcoor <> -400 THEN x3d = xcoor + (1 - 100 / ((400 + zcoor) / 4)) * (xH - xcoor)
END FUNCTION

FUNCTION y3d (ycoor, zcoor, yH)
IF zcoor <> -400 THEN y3d = ycoor + (1 - 100 / ((400 + zcoor) / 4)) * (yH - ycoor)
END FUNCTION

